#include "stdafx.h"
#include "textworks.h"

////////////////////////////////////////////////////////////////////////////
//
// Remove some HTML tags from the string
//
void DeHTML(string *tempstr, string sNewLine)
{
	char *tmp = new char[tempstr->length()+1];
	StringCchCopy(tmp, tempstr->length()+1, tempstr->c_str());
	string str;
	int i=0;
	while (tmp[i])
	{
		if (strnicmp(tmp+i, "&lt;", 4) == 0)
		{
			str += '<';
			i+=4;
		} else if (strnicmp(tmp+i, "&gt;", 4) == 0)
		{
			str += '>';
			i+=4;
		} else if (strnicmp(tmp+i, "&raquo;", 7) == 0)
		{
			str += '';
			i+=7;
		} else if (strnicmp(tmp+i, "&amp;", 5) == 0)
		{
			str += '&';
			i+=5;
		} else if (strnicmp(tmp+i, "&nbsp;", 6) == 0)
		{
			str += ' ';
			i+=6;
		} else if (strnicmp(tmp+i, "&deg;", 5) == 0)
		{
			str += '';
			i+=5;
		} else if (strnicmp(tmp+i, "&quot;", 6) == 0)
		{
			str = '\"';
			i+=6;
		} else if (strnicmp(tmp+i, "<br>", 4) == 0)
		{
			str += sNewLine;
			i+=4;
		} else if (strnicmp(tmp+i, "<br/>", 5) == 0)
		{
			str += sNewLine;
			i+=5;
		} else if (strnicmp(tmp+i, "<br />", 6) == 0)
		{
			str += sNewLine;
			i+=6;
		} else if (strnicmp(tmp+i, "<p>", 3) == 0)
		{
			str += sNewLine;
			i+=3;
		} else if (tmp[i] == '<')
		{
			// skip all unknown tags
			do i++; while (tmp[i]!='>');
			i++;
		} else
		{
			str += tmp[i];
			i++;
		}
	}
	*tempstr = str;
}


////////////////////////////////////////////////////////////////////////////
//
// Replace a with b
//
string str_replace(string str, const char *a, const char *b)
{
	string tmp = "";
	char *s = new char[str.length()+1];
	StringCchCopy(s, str.length()+1, str.c_str());

	char *p = s, *q;

	size_t alen = strlen(a);
	size_t blen = strlen(b);

	if (strncmp(p, a, alen) == 0)
	{
		tmp += b;
		p += alen;
	}

	q = strstr(p, a);
	while (q && *p)
	{
		*q = 0;
		tmp += p;
		tmp += b;
		p = q + alen;
		q = strstr(p, a);
	}

	tmp += p;

	delete s;
	return tmp;
}


////////////////////////////////////////////////////////////////////////////
//
// Generate output string using pattern
// 
bool GenerateText(StringVector *v, string sPattern, string *out, bool bIgnoreNewLine)
{
	char *szBuf = new char[sPattern.length()+1];
	char *szPattern = szBuf;
	StringCchCopy(szBuf, sPattern.length()+1, sPattern.c_str());
	int i = 0;	// position of the cursor in the pattern
	int j = 0;	//					and in the HTML file
	while (*szPattern)
	{
		if (!bIgnoreNewLine && strnicmp(szPattern, "\\\\", 2) == 0)
		{
			szPattern += 2;
			*out += "\\";
		} else
		if (!bIgnoreNewLine && strnicmp(szPattern, "\\n", 2) == 0)
		{
			szPattern +=2;
			*out += "\r\n";
		} else
		if (strnicmp(szPattern, "{%", 2) == 0)
		{
			szPattern += 2;
			char *err;
			int k = strtod(szPattern, &err);

			if (k<1 || *err != '}' || k>v->size())
			{
				delete szBuf;
				*out = "Invalid parameter id";
				return false;
			}
			*out += (*v)[k-1];
			szPattern = strchr(szPattern, '}') + 1;
		} else
		{
			*out += *szPattern;
			szPattern ++;
		}
	}
	delete szBuf;
	return true;
}


////////////////////////////////////////////////////////////////////////////
//
// Find first escape-sequence in the pattern
// 
char* FindFirstEscapeSequence(const char *szPattern)
{
	char *p1 = strstr(szPattern, "{*}");
	char *p2 = strstr(szPattern, "{%}");
	char *p3 = strstr(szPattern, "{%,");
	if (p2 == NULL || (p2 > p3 && p3 != NULL)) p2 = p3;
	if (p1 == NULL || (p1 > p2 && p2 != NULL)) p1 = p2;
	return p1;
}

